"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NumericInput = void 0;

var _react = _interopRequireWildcard(require("react"));

var _createRef = _interopRequireDefault(require("create-react-ref/lib/createRef"));

var _withTheme = require("./HOC/withTheme");

var _themes = require("../utils/themes");

var _ = require(".");

var _strings = require("../utils/strings");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DEFAULT_NUMBER_FORMAT = {
  groupSeparator: ',',
  decimalSeparator: '.'
};
// Always use known number format and transform it where necessary
var LOCALE = 'en-US';

var NumericInputBase =
/*#__PURE__*/
function (_Component) {
  _inherits(NumericInputBase, _Component);

  function NumericInputBase(props) {
    var _this;

    _classCallCheck(this, NumericInputBase);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(NumericInputBase).call(this, props));

    _defineProperty(_assertThisInitialized(_this), "inputElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "_hasInputBeenChanged", false);

    _defineProperty(_assertThisInitialized(_this), "onChange", function (event) {
      event.preventDefault();
      var _this$props = _this.props,
          value = _this$props.value,
          onChange = _this$props.onChange,
          disabled = _this$props.disabled;

      if (disabled) {
        return;
      }

      var result = _this.processValueChange(event.nativeEvent);

      if (result) {
        _this._hasInputBeenChanged = true;
        var hasValueChanged = value !== result.value;

        if (hasValueChanged && onChange) {
          onChange(result.value, event);
        }

        _this.setState({
          inputCaretPosition: result.caretPosition,
          minimumFractionDigits: result.minimumFractionDigits,
          fallbackInputValue: result.fallbackInputValue
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "setInputCaretPosition", function (position) {
      var _assertThisInitialize = _assertThisInitialized(_this),
          inputElement = _assertThisInitialize.inputElement;

      if (!inputElement.current) return;
      var input = inputElement.current;
      input.selectionStart = position;
      input.selectionEnd = position;
    });

    _defineProperty(_assertThisInitialized(_this), "focus", function () {
      var _assertThisInitialize2 = _assertThisInitialized(_this),
          inputElement = _assertThisInitialize2.inputElement;

      if (!inputElement.current) return;
      inputElement.current.focus();
    });

    _defineProperty(_assertThisInitialized(_this), "onBlur", function () {
      _this.setState({
        fallbackInputValue: null
      });
    });

    var context = props.context,
        numberLocaleOptions = props.numberLocaleOptions,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;
    _this.inputElement = (0, _createRef["default"])();
    var minimumFractionDigits = numberLocaleOptions ? numberLocaleOptions.minimumFractionDigits : 0;
    _this.state = {
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API),
      minimumFractionDigits: minimumFractionDigits || 0,
      inputCaretPosition: 0,
      fallbackInputValue: null
    };
    return _this;
  }

  _createClass(NumericInputBase, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var inputElement = this.inputElement;
      var autoFocus = this.props.autoFocus;

      if (autoFocus) {
        this.focus();

        if (inputElement && inputElement.current) {
          this.setState({
            inputCaretPosition: inputElement.current.selectionStart
          });
        }
      }
    }
  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      (0, _themes.didThemePropsChange)(this.props, nextProps, this.setState.bind(this));
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var value = this.props.value;
      var inputCaretPosition = this.state.inputCaretPosition;
      var hasValueBeenChanged = value !== prevProps.value;
      var hasCaretBeenChanged = inputCaretPosition !== prevState.inputCaretPosition;

      if (this._hasInputBeenChanged || hasValueBeenChanged || hasCaretBeenChanged) {
        this.setInputCaretPosition(inputCaretPosition);
      }

      this._hasInputBeenChanged = false;
    }
  }, {
    key: "processValueChange",

    /**
     * 1. Handle edge cases that don't need further processing
     * 2. Clean the given value
     * 3. Final processing
     */
    value: function processValueChange(event) {
      var _this$props2 = this.props,
          numberFormat = _this$props2.numberFormat,
          value = _this$props2.value,
          allowSigns = _this$props2.allowSigns;
      var changedCaretPosition = event.target.selectionStart;
      var valueToProcess = transformNumberFormat(event.target.value, numberFormat, DEFAULT_NUMBER_FORMAT);
      var inputType = event.inputType;
      var fallbackInputValue = this.state.fallbackInputValue || '';
      var isBackwardDelete = inputType === 'deleteContentBackward';
      var isForwardDelete = inputType === 'deleteContentForward';
      var isDeletion = isForwardDelete || isBackwardDelete;
      var isInsert = inputType === 'insertText';
      var deleteCaretCorrection = isBackwardDelete ? 0 : 1;
      var validInputSignsRegExp = new RegExp("^([-])?([0-9,.]+)?$"); // eslint-disable-line

      var validInputNoSignsRegExp = new RegExp("^([0-9,.]+)?$"); // eslint-disable-line

      var validInputRegex = allowSigns ? validInputSignsRegExp : validInputNoSignsRegExp;
      var valueHasLeadingZero = /^0[1-9]/.test(valueToProcess);
      /**
       * ========= HANDLE HARD EDGE-CASES =============
       */
      // Case: invalid characters entered -> refuse!

      if (!validInputRegex.test(valueToProcess)) {
        return {
          caretPosition: changedCaretPosition - 1,
          fallbackInputValue: fallbackInputValue,
          minimumFractionDigits: this.state.minimumFractionDigits,
          value: value
        };
      } // Case: Everything was deleted -> reset state


      if (valueToProcess === '') {
        return {
          value: null,
          caretPosition: 0,
          fallbackInputValue: null,
          minimumFractionDigits: 0
        };
      } // Case: value is the same as the fallback (which is always shown if defined)


      if (valueToProcess === this.state.fallbackInputValue) return null; // Case: Just minus sign was entered

      if (valueToProcess === '-') {
        return {
          value: null,
          caretPosition: 1,
          fallbackInputValue: '-',
          minimumFractionDigits: 0
        };
      }
      /**
       * ========= CLEAN THE INPUT =============
       */
      // Options


      var propsMinimumFractionDigits = this.getMinimumFractionDigits();
      var maximumFractionDigits = this.getMaximumFractionDigits();
      var numberLocaleOptions = this.getDynamicLocaleOptions(); // Current value

      var currentNumber = value;
      var currentValue = value != null ? value.toLocaleString(LOCALE, numberLocaleOptions) : fallbackInputValue;
      var currentNumberOfDots = getNumberOfDots(currentValue);
      var hadDotBefore = currentNumberOfDots > 0; // New Value

      var newValue = valueToProcess;
      var newCaretPosition = changedCaretPosition;
      var newNumberOfDots = getNumberOfDots(newValue); // Case: A second decimal point was added somewhere

      if (hadDotBefore && newNumberOfDots === 2) {
        var oldFirstDotIndex = currentValue.indexOf('.');
        var newFirstDotIndex = newValue.indexOf('.');
        var wasDotAddedBeforeOldOne = newFirstDotIndex < oldFirstDotIndex; // Remove the second decimal point and set caret position

        newValue = (0, _strings.removeCharAtPosition)(newValue, wasDotAddedBeforeOldOne ? newValue.lastIndexOf('.') : oldFirstDotIndex);
        newCaretPosition = newValue.indexOf('.') + 1;
      }

      newValue = truncateToPrecision(newValue, maximumFractionDigits);
      /**
       * ========= PROCESS CLEANED INPUT =============
       */

      var numberOfFractionDigits = getFractionDigits(newValue).length;
      var dynamicMinimumFractionDigits = Math.min(Math.max(propsMinimumFractionDigits, numberOfFractionDigits), maximumFractionDigits);
      var newNumber = getValueAsNumber(newValue, maximumFractionDigits); // Case: Just a dot was entered

      if (valueToProcess === '.') {
        var hasMinFractions = dynamicMinimumFractionDigits > 0;
        return {
          value: 0,
          caretPosition: 2,
          fallbackInputValue: hasMinFractions ? null : '0.',
          minimumFractionDigits: dynamicMinimumFractionDigits
        };
      } // Case: Dot was added at the beginning of number


      if (newValue.charAt(0) === '.') {
        var newCaretPos = isInsert ? 2 : 1;
        return {
          value: newNumber,
          caretPosition: newCaretPos,
          minimumFractionDigits: dynamicMinimumFractionDigits
        };
      } // Case: Invalid change has been made -> ignore it


      if (newNumber == null) {
        var deleteAdjustment = isBackwardDelete ? 0 : 1; // special cases when deleting dot

        var insertAdjustment = -1; // don't move caret if numbers are "inserted"

        return {
          caretPosition: changedCaretPosition + (isDeletion ? deleteAdjustment : insertAdjustment),
          fallbackInputValue: fallbackInputValue,
          minimumFractionDigits: dynamicMinimumFractionDigits,
          value: currentNumber
        };
      }

      var localizedNewNumber = newNumber.toLocaleString(LOCALE, {
        minimumFractionDigits: dynamicMinimumFractionDigits
      }); // Case: Dot was added at the end of number

      if (!isDeletion && newValue.charAt(newValue.length - 1) === '.') {
        return {
          value: newNumber,
          caretPosition: changedCaretPosition,
          fallbackInputValue: propsMinimumFractionDigits > 0 ? null : localizedNewNumber + '.',
          minimumFractionDigits: 0
        };
      } // Case: Dot was deleted with minimum fraction digits constrain defined


      var hasFractions = this.getMinimumFractionDigitsProp() != null;
      var wasDotRemoved = hadDotBefore && !newNumberOfDots;

      if (wasDotRemoved && hasFractions && !isInsert) {
        return {
          caretPosition: newCaretPosition + deleteCaretCorrection,
          fallbackInputValue: null,
          minimumFractionDigits: dynamicMinimumFractionDigits,
          value: currentNumber
        };
      } // Case: Valid change has been made


      var hasNumberChanged = value !== newNumber;
      var commasDiff = getNumberOfCommas(localizedNewNumber) - getNumberOfCommas(newValue);
      var haveCommasChanged = commasDiff > 0;
      var onlyCommasChanged = !hasNumberChanged && haveCommasChanged;
      var leadingZeroCorrection = valueHasLeadingZero ? -1 : 0;
      var caretCorrection = (onlyCommasChanged ? deleteCaretCorrection : commasDiff) + leadingZeroCorrection;
      return {
        caretPosition: Math.max(newCaretPosition + caretCorrection, 0),
        fallbackInputValue: null,
        minimumFractionDigits: dynamicMinimumFractionDigits,
        value: newNumber
      };
    }
  }, {
    key: "getMinimumFractionDigitsProp",
    value: function getMinimumFractionDigitsProp() {
      var numberLocaleOptions = this.props.numberLocaleOptions;
      if (!numberLocaleOptions) return null;
      var minimumFractionDigits = numberLocaleOptions.minimumFractionDigits;
      return minimumFractionDigits || null;
    }
  }, {
    key: "getMinimumFractionDigits",
    value: function getMinimumFractionDigits() {
      return this.getMinimumFractionDigitsProp() || 0;
    }
  }, {
    key: "getDynamicMinimumFractionDigits",
    value: function getDynamicMinimumFractionDigits() {
      var minimumFractionDigitsProp = this.getMinimumFractionDigits();
      return Math.max(this.state.minimumFractionDigits, minimumFractionDigitsProp || 0);
    }
  }, {
    key: "getMaximumFractionDigits",
    value: function getMaximumFractionDigits() {
      var numberLocaleOptions = this.props.numberLocaleOptions;
      var minimumFractionDigits = this.getDynamicMinimumFractionDigits();
      var maximumFractionDigits = numberLocaleOptions && numberLocaleOptions.maximumFractionDigits != null ? numberLocaleOptions.maximumFractionDigits : 3;
      return Math.max(minimumFractionDigits, maximumFractionDigits);
    }
  }, {
    key: "getDynamicLocaleOptions",
    value: function getDynamicLocaleOptions() {
      return Object.assign({}, this.props.numberLocaleOptions, {
        minimumFractionDigits: this.getDynamicMinimumFractionDigits()
      });
    }
  }, {
    key: "getLocalizedNumber",
    value: function getLocalizedNumber(value) {
      return convertNumberToLocalizedString(value, LOCALE, this.getDynamicLocaleOptions());
    }
  }, {
    key: "render",
    value: function render() {
      // destructuring props ensures only the "...rest" get passed down
      var _this$props3 = this.props,
          context = _this$props3.context,
          error = _this$props3.error,
          numberLocaleOptions = _this$props3.numberLocaleOptions,
          onChange = _this$props3.onChange,
          skin = _this$props3.skin,
          theme = _this$props3.theme,
          themeOverrides = _this$props3.themeOverrides,
          value = _this$props3.value,
          rest = _objectWithoutProperties(_this$props3, ["context", "error", "numberLocaleOptions", "onChange", "skin", "theme", "themeOverrides", "value"]);

      var InputSkin = skin || context.skins[_.IDENTIFIERS.INPUT];
      var localizedInput = value != null ? this.getLocalizedNumber(value) : '';
      var inputValue = this.state.fallbackInputValue ? this.state.fallbackInputValue : localizedInput;
      return _react["default"].createElement(InputSkin, _extends({
        error: error,
        inputRef: this.inputElement,
        onChange: this.onChange,
        theme: this.state.composedTheme,
        value: transformNumberFormat(inputValue, DEFAULT_NUMBER_FORMAT, this.props.numberFormat),
        onBlur: this.onBlur
      }, rest));
    }
  }]);

  return NumericInputBase;
}(_react.Component);

_defineProperty(NumericInputBase, "displayName", 'NumericInput');

_defineProperty(NumericInputBase, "defaultProps", {
  allowSigns: true,
  context: (0, _withTheme.createEmptyContext)(),
  numberFormat: DEFAULT_NUMBER_FORMAT,
  readOnly: false,
  theme: null,
  themeId: _.IDENTIFIERS.INPUT,
  themeOverrides: {},
  value: null
});

var NumericInput = (0, _withTheme.withTheme)(NumericInputBase); // ========= HELPERS ==========

exports.NumericInput = NumericInput;
var NUMERIC_INPUT_REGEX = /^([-])?([0-9,]+)?(\.([0-9]+)?)?$/;

var isValidNumericInput = function isValidNumericInput(value) {
  return NUMERIC_INPUT_REGEX.test(value);
};

var isParsableNumberString = function isParsableNumberString(value, requiredPrecision) {
  return (// The number of digits is limited in Javascript - so the required precision influence
    // the possible number of integer digits (only 15 digits can be safely represented in total)
    parseFloat(value) >= Number.MIN_SAFE_INTEGER / Math.pow(10, requiredPrecision + 1) && parseFloat(value) <= Number.MAX_SAFE_INTEGER / Math.pow(10, requiredPrecision + 1) && !isNaN(parseFloat(value)) && isFinite(value)
  );
};

var removeCommas = function removeCommas(value) {
  return value.replace(/,/g, '');
};

function parseStringToNumber(value, requiredPrecision) {
  var cleanedValue = removeCommas(value);
  if (!isValidNumericInput(cleanedValue)) return null;
  if (!isParsableNumberString(cleanedValue, requiredPrecision)) return null;
  return parseFloat(cleanedValue);
}

function convertNumberToLocalizedString(num, locale, options) {
  return num != null ? num.toLocaleString(locale, options) : '';
}

function getValueAsNumber(value, requiredPrecision) {
  return typeof value === 'string' ? parseStringToNumber(value, requiredPrecision) : value;
}

function getNumberOfCommas(value) {
  return (value.match(/,/g) || []).length;
}

function getNumberOfDots(value) {
  return (value.match(/\./g) || []).length;
}

function getIntegerDigits(value) {
  var decimalSeparator = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '.';
  var fractionSeparatorIndex = value.indexOf(decimalSeparator);
  if (fractionSeparatorIndex === -1) return value;
  return value.substring(0, fractionSeparatorIndex);
}

function getFractionDigits(value) {
  var decimalSeparator = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '.';
  var fractionSeparatorIndex = value.indexOf(decimalSeparator);
  if (fractionSeparatorIndex === -1) return '';
  return value.substring(fractionSeparatorIndex + 1);
}

function truncateToPrecision(value, precision) {
  var decimalPointIndex = value.indexOf('.');
  if (decimalPointIndex === -1) return value;
  var fractionDigits = removeCommas(getFractionDigits(value));
  return getIntegerDigits(value) + '.' + fractionDigits.substring(0, precision);
}

function transformNumberFormat(value, inputFormat, outputFormat) {
  return value.replace(new RegExp('\\' + inputFormat.groupSeparator, 'g'), '#').replace(new RegExp('\\' + inputFormat.decimalSeparator, 'g'), '@').replace(new RegExp('#', 'g'), outputFormat.groupSeparator).replace(new RegExp('@', 'g'), outputFormat.decimalSeparator);
}
//# sourceMappingURL=NumericInput.js.map